/* bhbanner.cpp
 *
 * Copyright (C) 2004 Al Kingsley
 */
#include "config.h"
#include "bhbanner.h"
#include "bhintl.h"

namespace bhpos{

namespace widget{

BhBanner::BhBanner(BaseObjectType* cobject) : Gtk::HBox(cobject)
{
   
}

BhBanner::BhBanner(char *id) : Gtk::HBox()
{
   char imd[255], a[255], b[255], c[255], d[255];
   
   strcpy(imd, id);
   strcat(imd, "/banner2.png");
   
   calign = Gtk::manage(new class Gtk::Alignment(0, 0.5)); 
   talign = Gtk::manage(new class Gtk::Alignment(1, .05));
   balign = Gtk::manage(new class Gtk::Alignment(0.5, 0.5));
   Glib::RefPtr<Gdk::Pixbuf> pb = Gdk::Pixbuf::create_from_file(imd);
   banner = Gtk::manage(new class Gtk::Image(pb)); 
      
   banner->set_alignment(0.5,0.5);
   banner->set_padding(0,0);

   strcpy(imd, id);
   strcpy(a, id);
   strcpy(b, id);
   strcpy(c, id);
   strcpy(d, id);
   strcat(imd, "/clock_facia.png");
   strcat(a, "/clock_date.png");
   strcat(b, "/clock_day.png");
   strcat(c, "/clock_month.png");
   strcat(d, "/clock_time.png");
   clock = Gtk::manage(new class bhpos::widget::BhClock());
   clock->Load(imd, a, b, c, d);
   clock->set_size_request(64,64);
   
   strcpy(imd, id);
   strcpy(a, id);
   strcpy(b, id);
   strcat(imd, "/total_facia.png");
   strcat(a, "/total_pos_dig.png");
   strcat(b, "/total_neg_dig.png");
   total_disp = Gtk::manage(new class bhpos::widget::BhDisplay());
   total_disp->Load(imd, a, b);
   total_disp->set_size_request(total_disp->GetXSize(),64);
   
   set_border_width(10);
   calign->add(*clock);
   balign->add(*banner);
   talign->add(*total_disp);
   
   pack_start(*calign, Gtk::PACK_SHRINK);
   pack_start(*balign, Gtk::PACK_EXPAND_PADDING);
   pack_start(*talign, Gtk::PACK_SHRINK);

   show_all();
   total_disp->Set(0.0);
}
  
BhBanner::~BhBanner()
{
}

void BhBanner::SetTotal(double d)
{
   total_disp->Set(d);
}

}

}
