/*
bhbookbox.h
Copyright (C) 2005 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Don't write to me at: kingsley@bananahead.com 
*/

#ifndef _BHBOOKOX_H
#include <gtkmm/dialog.h>
#include <gtkmm/button.h>
#include <gtkmm/image.h>
#include <gtkmm/label.h>
#include <gtkmm/entry.h>
#include <gtkmm/table.h>

namespace bhpos{

/**
 * @ingroup mflib
 * @{	
 */
   
namespace widget{

/**
 * @defgroup bhbookbox Book Box
 * @{
 *
 * @ingroup bhwidget
 * @{	
 */
#define _BHBOOKBOX_H

class bhbookbox : public Gtk::Dialog
{
protected:
   class Gtk::Label  *l_msg;
   class Gtk::Label  *l_isbn;
   class Gtk::Label  *l_title;
   class Gtk::Label  *l_author;
   class Gtk::Image  *icon;
   class Gtk::Entry  *isbn;
   class Gtk::Entry  *btitle;
   class Gtk::Entry  *author;
	class Gtk::Button *yes;
	class Gtk::Button *no;
   
   sigc::signal<void, Glib::ustring&, Glib::ustring&, Glib::ustring&> event_signal;

public:
   bhbookbox(Glib::ustring& title, Glib::ustring& imagefile, Glib::ustring& message);
   sigc::signal<void, Glib::ustring&, Glib::ustring&, Glib::ustring&> signal_event(){ return event_signal; }
   void on_isbn_changed();
   void Set(Glib::ustring&, Glib::ustring&, Glib::ustring&);
   void on_yes_clicked();
   void on_no_clicked();
};

/* @} 
	@} */

}

/* @} */

}

#endif
