/*
bhclock.cpp
Copyright (C) 2003  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include <unistd.h>
#include <fcntl.h>
#include "bhclock.h"

namespace bhpos{
   
namespace widget{

BhClock::BhClock()
{
	xsMonth[0] = 0;
	xsMonth[1] = 20;
	xsMonth[2] = 40;
	xsMonth[3] = 62;
	xsMonth[4] = 83;
	xsMonth[5] = 106;
	xsMonth[6] = 126;
	xsMonth[7] = 144;
	xsMonth[8] = 167;
	xsMonth[9] = 187;
	xsMonth[10] =207;
	xsMonth[11] =230;
   
   xeMonth[0] = 19;
	xeMonth[1] = 39;
	xeMonth[2] = 61;
	xeMonth[3] = 82;
	xeMonth[4] = 105;
	xeMonth[5] = 125;
	xeMonth[6] = 143;
	xeMonth[7] = 166;
	xeMonth[8] = 186;
	xeMonth[9] = 206;
	xeMonth[10] =229;
   xeMonth[11] =249;
	
	ydMonth = 12;

	xsDayOfWeek[0] = 0;
	xsDayOfWeek[1] = 22;
	xsDayOfWeek[2] = 48;
	xsDayOfWeek[3] = 71;
	xsDayOfWeek[4] = 97;
	xsDayOfWeek[5] = 120;
	xsDayOfWeek[6] = 137;
	
	xeDayOfWeek[0] = 22;
	xeDayOfWeek[1] = 48;
	xeDayOfWeek[2] = 71;
	xeDayOfWeek[3] = 97;
	xeDayOfWeek[4] = 120;
	xeDayOfWeek[5] = 137;
	xeDayOfWeek[6] = 157;
	
	ydDayOfWeek = 12;
   
   xsDayOfMonth[0] = 0;
	xsDayOfMonth[1] = 33;
	xsDayOfMonth[2] = 63;
	xsDayOfMonth[3] = 97; 
	xsDayOfMonth[4] = 130;
	xsDayOfMonth[5] = 165;
	xsDayOfMonth[6] = 198;
	xsDayOfMonth[7] = 233;
	xsDayOfMonth[8] = 267;
	xsDayOfMonth[9] = 303; 
	xsDayOfMonth[10] = 337;
	xsDayOfMonth[11] = 370;
	xsDayOfMonth[12] = 399;
	xsDayOfMonth[13] = 432;
	xsDayOfMonth[14] = 463;
	xsDayOfMonth[15] = 498;
	xsDayOfMonth[16] = 528;
	xsDayOfMonth[17] = 562;
	xsDayOfMonth[18] = 594;
	xsDayOfMonth[19] = 626;
	xsDayOfMonth[20] = 660;
	xsDayOfMonth[21] = 694;
	xsDayOfMonth[22] = 723;
	xsDayOfMonth[23] = 756;
	xsDayOfMonth[24] = 790;
	xsDayOfMonth[25] = 824;
	xsDayOfMonth[26] = 856;
	xsDayOfMonth[27] = 890;
	xsDayOfMonth[28] = 925;
	xsDayOfMonth[29] = 957;
   xsDayOfMonth[30] = 991;
   xsDayOfMonth[31] = 1025;
   
	xeDayOfMonth[0] = 32;
	xeDayOfMonth[1] = 62;
	xeDayOfMonth[2] = 96; 
	xeDayOfMonth[3] = 129;
	xeDayOfMonth[4] = 164;
	xeDayOfMonth[5] = 197;
	xeDayOfMonth[6] = 232;
	xeDayOfMonth[7] = 266;
	xeDayOfMonth[8] = 302; 
	xeDayOfMonth[9] = 336;
	xeDayOfMonth[10] = 369;
	xeDayOfMonth[11] = 398;
	xeDayOfMonth[12] = 431;
	xeDayOfMonth[13] = 462;
	xeDayOfMonth[14] = 497;
	xeDayOfMonth[15] = 527;
	xeDayOfMonth[16] = 561;
	xeDayOfMonth[17] = 593;
	xeDayOfMonth[18] = 625;
	xeDayOfMonth[19] = 659;
	xeDayOfMonth[20] = 693;
	xeDayOfMonth[21] = 723;
	xeDayOfMonth[22] = 755;
	xeDayOfMonth[23] = 789;
	xeDayOfMonth[24] = 823;
	xeDayOfMonth[25] = 855;
	xeDayOfMonth[26] = 889;
	xeDayOfMonth[27] = 924;
	xeDayOfMonth[28] = 956;
   xeDayOfMonth[29] = 990;
   xeDayOfMonth[30] = 1024;
   xeDayOfMonth[31] = 1054;

	ydDayOfMonth = 23;

	xsDigits[0]  = 0;
	xsDigits[1]  = 10;
	xsDigits[2]  = 14;
	xsDigits[3]  = 22;
	xsDigits[4]  = 31;
	xsDigits[5]  = 40;
	xsDigits[6]  = 49;
	xsDigits[7]  = 59;
	xsDigits[8]  = 68;
	xsDigits[9]  = 78;
	xsDigits[10] = 87;
   xsDigits[11] = 89;
	
	xeDigits[0] = 9;
	xeDigits[1] = 13;
	xeDigits[2] = 21;
	xeDigits[3] = 30;
	xeDigits[4] = 39;
	xeDigits[5] = 48;
	xeDigits[6] = 58;
	xeDigits[7] = 67;
	xeDigits[8] = 77;
	xeDigits[9] = 86;
	xeDigits[10] =88;
   xeDigits[11] =90;
		
	ydDigits = 12;
	
	xsAMPM[0]=91;
	xsAMPM[1]=97;
	xdAMPM[0]=6;
	xdAMPM[1]=5;
	ydAMPM=7;
	
   bColon=true;
	Show24HourTime=true;
	Flag = 0;
	dFlag=1;
   n = 32000;
   OldDayOfMonth = -1;
   OldMins=-1;

	CurrentLocalTime = time(&CurrentTime);
	Time = localtime(&CurrentLocalTime);
	DayOfMonth = Time->tm_mday-1;
	DayOfWeek = Time->tm_wday;
	Month = Time->tm_mon;
	Hours = Time->tm_hour;
	Mins  = Time->tm_min;
	Secs  = Time->tm_sec;

	/* Flag indicates AM (Flag=0)  or PM (Flag=1)  */
	if(!Show24HourTime){
		Flag  = (Hours >= 12) ? 1 : 0;
		if(Hours == 0)
		    Hours = 12;
		else 
		    Hours = (Hours > 12) ? Hours-12 : Hours;    
	}
   //this->signal_expose_event().connect(sigc::ptr_fun(&BhClock::on_expose_event));
   //this->signal_realize().connect(sigc::ptr_fun(&BhClock::on_realize));
}

BhClock::~BhClock()
{
}

void BhClock::on_realize()
{
	// we need to do the default realize
   Gtk::DrawingArea::on_realize();
	//size(64, 64);
   window = get_window();
   gc = Gdk::GC::create(window);
}

bool BhClock::on_expose_event(GdkEventExpose *e)
{   
   Update();
	return true;
}

gint BhClock::Load(const std::string& facianame, const std::string& datename, const std::string& dayname, const std::string& monthname, const std::string& timename)
{
	//realize();
   final = Gdk::Pixbuf::create_from_file(facianame);
   facia = Gdk::Pixbuf::create_from_file(facianame);
   date = Gdk::Pixbuf::create_from_file(datename);
   day = Gdk::Pixbuf::create_from_file(dayname);
   month = Gdk::Pixbuf::create_from_file(monthname);
   timen = Gdk::Pixbuf::create_from_file(timename);
   
   sigc::slot<bool> clock_slot = sigc::mem_fun(*this, &BhClock::Update);
   conn = Glib::signal_timeout().connect(clock_slot, 900);
	
   return 0;
}

bool BhClock::Update()
{
	n = 32000;
   OldDayOfMonth = -1;

	CurrentLocalTime = time(&CurrentTime);
	Time = localtime(&CurrentLocalTime);
	DayOfMonth = Time->tm_mday-1;
	DayOfWeek = Time->tm_wday;
	Month = Time->tm_mon;
	Hours = Time->tm_hour;
	Mins  = Time->tm_min;
	Secs  = Time->tm_sec;

	/* Flag indicates AM (Flag=0)  or PM (Flag=1)  */
	if(!Show24HourTime){
		Flag  = (Hours >= 12) ? 1 : 0;
		if(Hours == 0)
		    Hours = 12;
		else 
		    Hours = (Hours > 12) ? Hours-12 : Hours;    
	}

   /* Blank the HH:MM section....  */
	xsize = 0;
	/* dont show leading zeros */
	if((digit = Hours / 10) > 0){
		D[0] = digit;
	} 
	else{
		D[0] = -1;
	}
	digit = Hours % 10, D[1] = digit;
	digit = 10,         D[2] = digit;
	digit = Mins / 10,  D[3] = digit;
	digit = Mins % 10,  D[4] = digit;
	
	xoff = ((Hours>9)&&(!Show24HourTime)) ? 28 - xsize/2 : 31 - xsize/2;
	
	Draw();
   if(OldMins!=D[4]) OldMins=D[4];
	OldDayOfMonth = DayOfMonth;
   
   return true;
}

void BhClock::DrawTime()
{
   int xoffset=30, xs;
   
   if(!Show24HourTime){
      xoffset=24;
   }
   // Draw Hours 
	// dont show leading zeros 
	if(D[0] > -1){
		digit = D[1];
      xs=xoffset-((xeDigits[digit] - xsDigits[digit])+1);
      digit = D[0];
      xs-=(xeDigits[digit] - xsDigits[digit])+2;
      timen->copy_area(xsDigits[digit], 0, xeDigits[digit] - xsDigits[digit]+1, ydDigits, final, xs, 6);
	}

	digit = D[1];
   xs=xoffset-((xeDigits[digit] - xsDigits[digit])+1);
   timen->copy_area(xsDigits[digit], 0, xeDigits[digit] - xsDigits[digit]+1, ydDigits, final, xs, 6);

   // Draw Minutes
	digit = D[3];
   timen->copy_area(xsDigits[digit], 0, xeDigits[digit] - xsDigits[digit]+1, ydDigits, final, xoffset+4, 6);
	xs=xoffset+((xeDigits[digit] - xsDigits[digit])+5);

	digit = D[4];
   timen->copy_area(xsDigits[digit], 0, xeDigits[digit] - xsDigits[digit]+1, ydDigits, final, xs, 6);

	// Draw AM/PM indicator if we are using 12 Hour Clock.
	if(!Show24HourTime){
      // NOT DONE...
      //timen->copy_area(xsDigits[digit], 0, xeDigits[digit] - xsDigits[digit], ydDigits, final, xoff, 5);
      //copyXPMArea(xsAMPM[Flag], yAMPM, xdAMPM[Flag], ydAMPM, 54, 5);
   }
}

void BhClock::DrawDayMonth()
{
   wid = (64 - ((xeDayOfWeek[DayOfWeek]-xsDayOfWeek[DayOfWeek]) + (xeMonth[Month]-xsMonth[Month])))/2;
   int did = (64 - (xeDayOfMonth[DayOfMonth] - xsDayOfMonth[DayOfMonth]))/2;
	
   day->copy_area(xsDayOfWeek[DayOfWeek], 0, (xeDayOfWeek[DayOfWeek]-xsDayOfWeek[DayOfWeek]), ydDayOfWeek, final, wid, 48);
   month->copy_area(xsMonth[Month], 0, (xeMonth[Month]-xsMonth[Month]), ydMonth, final, 64-wid-(xeMonth[Month]-xsMonth[Month]), 48);
   date->copy_area(xsDayOfMonth[DayOfMonth+1], 0, (xeDayOfMonth[DayOfMonth+1] - xsDayOfMonth[DayOfMonth+1]), 23, final, did, 25);
}

void BhClock::Draw()
{  
   if(OldMins != D[4]){
      OldMins = D[4];
      facia->copy_area(0, 0, 64, 64, final, 0, 0);
      DrawTime();
      if(OldDayOfMonth != DayOfMonth){
		   // Blank the Calendar section....
		   // copyXPMArea(5, 70, 54, 35, 5, 24);
   		// copyXPMArea(54, 35, 5, 70, 5, 24);
	   	// Draw Day of Week and Month 
		   DrawDayMonth();
	   }
   }
   if(bColon){
	   digit = 10;
      bColon=false;
   }
   else{
      digit = 11;
      bColon=true;
   }
   timen->copy_area(xsDigits[digit], 0, xeDigits[digit] - xsDigits[digit]+1, ydDigits, final, 31, 6);
   final->render_to_drawable(window, gc, 0, 0, 0, 0, 64,64,Gdk::RGB_DITHER_NONE, 0, 0);
}

// Compute the Julian Day number for the given date. Julian Date is the number of days since noon of Jan 1 4713 B.C. 
double BhClock::JulianDay(int ny, int nm, int nd, double UT)
{
	double A, B, C, D, day;

	day = nd + UT/24.0;
	if((nm == 1) || (nm == 2)){
		ny = ny - 1;
      nm = nm + 12;
	}

   if (((double) ny+nm / 12.0 + day/365.25 ) >= (1582.0+10.0 / 12.0 + 15.0 / 365.25)){
		A = ((int)(ny / 100.0));
      B = 2.0 - A + (int)(A/4.0);
	}
   else{
		B = 0.0;
	}

   if(ny < 0.0){
		C = (int)((365.25 * (double) ny) - 0.75);
	}
   else{
		C = (int)(365.25*(double)ny);
	}

   D = (int)(30.6001 * (double) (nm + 1));


	return ((double) (B + C + D + day + 1720994.5));
}

double BhClock::Hour24(double hour)
{
	int n;

   if(hour < 0.0){
		n=(int) ( hour / 24.0) - 1;
      return (hour - n * 24.0);
	}
   else if(hour > 24.0){
		n=(int) (hour / 24.0);
		return (hour - n * 24.0);
	}
   else{
		return (hour);
	}
}

}

}
