/*
bhdisplay.cpp
Copyright (C) 2004 Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2004 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#include "bhdisplay.h"
#include <cstring>
#include <math.h>
#include <sigc++/sigc++.h>

namespace bhpos{
   
namespace widget{

BhDisplay::BhDisplay()
{
	xsDigits[0]  = 0;
	xsDigits[1]  = 30;
	xsDigits[2]  = 38;
	xsDigits[3]  = 68;
	xsDigits[4]  = 98;
	xsDigits[5]  = 128;
	xsDigits[6]  = 158;
	xsDigits[7]  = 188;
	xsDigits[8]  = 218;
	xsDigits[9]  = 248;
	xsDigits[10] = 278;
   	
	xeDigits[0] = 29;
	xeDigits[1] = 37;
	xeDigits[2] = 67;
	xeDigits[3] = 97;
	xeDigits[4] = 127;
	xeDigits[5] = 157;
	xeDigits[6] = 187;
	xeDigits[7] = 217;
	xeDigits[8] = 247;
	xeDigits[9] = 277;
	xeDigits[10] =284;

   num_ldig=4;
	number=0.0;
   bNegDigits=false;
   //this->signal_expose_event().connect(sigc::fun_ptr(&BhDisplay::on_expose_event));
   //this->signal_realize().connect(sigc::fun_ptr(&BhDisplay::on_realize));
}

BhDisplay::BhDisplay(int nd)
{
	xsDigits[0]  = 0;
	xsDigits[1]  = 30;
	xsDigits[2]  = 38;
	xsDigits[3]  = 68;
	xsDigits[4]  = 98;
	xsDigits[5]  = 128;
	xsDigits[6]  = 158;
	xsDigits[7]  = 188;
	xsDigits[8]  = 218;
	xsDigits[9]  = 248;
	xsDigits[10] = 278;
   	
	xeDigits[0] = 29;
	xeDigits[1] = 37;
	xeDigits[2] = 67;
	xeDigits[3] = 97;
	xeDigits[4] = 127;
	xeDigits[5] = 157;
	xeDigits[6] = 187;
	xeDigits[7] = 217;
	xeDigits[8] = 247;
	xeDigits[9] = 277;
	xeDigits[10] =284;

   num_ldig=nd;
	number=0.0;
   bNegDigits=false;
   //this->signal_expose_event().connect(sigc::fun_ptr(&BhDisplay::on_expose_event));
   //this->signal_realize().connect(sigc::fun_ptr(&BhDisplay::on_realize));
}

BhDisplay::~BhDisplay()
{
}

void BhDisplay::on_realize()
{
	// we need to do the default realize
   Gtk::DrawingArea::on_realize();
	//size(64, 64);
   window = get_window();
   gc = Gdk::GC::create(window);
}

bool BhDisplay::on_expose_event(GdkEventExpose *e)
{
   Draw();
	return true;
}

gint BhDisplay::Load(const std::string& facianame, const std::string& digitname)
{
	//realize();
   final = Gdk::Pixbuf::create_from_file(facianame);
   facia = Gdk::Pixbuf::create_from_file(facianame);
   digits = Gdk::Pixbuf::create_from_file(digitname);
	bNegDigits=false;
   return 0;
}

gint BhDisplay::Load(const std::string& facianame, const std::string& posdigname, const std::string& negdigname)
{
	//realize();
   final = Gdk::Pixbuf::create_from_file(facianame);
   facia = Gdk::Pixbuf::create_from_file(facianame);
   digits = Gdk::Pixbuf::create_from_file(posdigname);
	negdigits = Gdk::Pixbuf::create_from_file(negdigname);
   bNegDigits=true;
   return 0;
}

int BhDisplay::GetXSize()
{
   return 75+(29 * num_ldig);
}

void BhDisplay::Set(double n)
{
   char   buff[8];
   
   sprintf(buff, "%0.2f", n);
   number=atof(buff);
   Draw();
}

void BhDisplay::Draw()
{
   int    num, c;
   int    xs=164;
   int    dig[2];
   char   buff[8], tb[2];
   double in;
   double dn;
   double bob;
   long   cheese;
   int    xwidth=75+(29 * num_ldig);
   
   facia->copy_area(0, 0, xwidth, 64, final, 0, 0);
   
   dn=modf(number, &in);
   dn*=10;
   bob=modf(dn, &in);
   bob*=10;
   num=lrintf(bob);

   xs=196-(xeDigits[num] - xsDigits[num]);
   xs=(xwidth-4)-(xeDigits[num] - xsDigits[num]);
   if(bNegDigits){
      if(number < 0.0){
         negdigits->copy_area(xsDigits[num], 0, xeDigits[num] - xsDigits[num], 60, final, xs, 2);
      }
      else{
         digits->copy_area(xsDigits[num], 0, xeDigits[num] - xsDigits[num], 60, final, xs, 2);
      }
   }
   else{
      digits->copy_area(xsDigits[num], 0, xeDigits[num] - xsDigits[num], 60, final, xs, 2);
   }
   xs-=3;

   num=(int) in;
   xs-=(xeDigits[num] - xsDigits[num]);
   if(bNegDigits){
      if(number < 0.0){
         negdigits->copy_area(xsDigits[num], 0, xeDigits[num] - xsDigits[num], 60, final, xs, 2);
      }
      else{
         digits->copy_area(xsDigits[num], 0, xeDigits[num] - xsDigits[num], 60, final, xs, 2);
      }
   }
   else{
      digits->copy_area(xsDigits[num], 0, xeDigits[num] - xsDigits[num], 60, final, xs, 2);
   }
   xs-=8;
   
   if(bNegDigits){
      if(number < 0.0){
         negdigits->copy_area(xsDigits[10], 0, xeDigits[10] - xsDigits[10], 60, final, xs, 2);
      }
      else{
         digits->copy_area(xsDigits[10], 0, xeDigits[10] - xsDigits[10], 60, final, xs, 2);
      }
   }
  
   dn=modf(number, &in);
   xs-=2;
   if(in==0.0){
      xs-=(xeDigits[0] - xsDigits[0]);
      digits->copy_area(xsDigits[0], 0, xeDigits[0] - xsDigits[0], 60, final, xs, 2);
      final->render_to_drawable(window, gc, 0, 0, 0, 0, xwidth,64,Gdk::RGB_DITHER_NONE, 0, 0);
      return;
   }

   sprintf(buff, "%d", (int) in);
   c=strlen(buff)-1;
   dn=(in * (10 ^ c));
   int x=c;
   c++;
   
   while(c){
      num=NumRef(buff[x]);
      //num = (int) ((int) in % (int) dn);
      xs-=(xeDigits[num] - xsDigits[num]);
      if(bNegDigits){
         if(number < 0.0){
            negdigits->copy_area(xsDigits[num], 0, xeDigits[num] - xsDigits[num], 60, final, xs, 2);
         }
         else{
            digits->copy_area(xsDigits[num], 0, xeDigits[num] - xsDigits[num], 60, final, xs, 2);
         }
      }
      else{
         digits->copy_area(xsDigits[num], 0, xeDigits[num] - xsDigits[num], 60, final, xs, 2);
      }
      xs-=3;
      c--;
      x--;
      dn=(in * (10 ^ c));
   }
   final->render_to_drawable(window, gc, 0, 0, 0, 0, xwidth,64,Gdk::RGB_DITHER_NONE, 0, 0);
}

int BhDisplay::NumRef(char c)
{
   switch(c){
   case '0': return 0;
   case '1': return 1;
   case '2': return 2;
   case '3': return 3;
   case '4': return 4;
   case '5': return 5;
   case '6': return 6;
   case '7': return 7;
   case '8': return 8;
   case '9': return 9;
   }
}

}

}
