/*
bhdisplay.h
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#ifndef _BHDISPLAY_H_
#define _BHDISPLAY_H_

#include <gtkmm/main.h>
#include <gtkmm/window.h>
#include <gtkmm/drawingarea.h>
#include <gdkmm/color.h>
#include <gdkmm/gc.h>

namespace bhpos{

/**
 * \ingroup mflib
 * \@{	
 */

namespace widget{
/**
 * \defgroup bhdisplay Total Display
 * \@{
 *
 * \ingroup bhwidget
 * \@{	
 */
   
/*! BhDisplay
   \brief A class to handle a total display.*/
class BhDisplay : public Gtk::DrawingArea
{
private:
   int	 xsDigits[11], xeDigits[11], xdDigits[11], ydDigits;
   int    num_ldig;
	double number;
   bool   bNegDigits;
   int    NumRef(char c);
   
protected:
   Glib::RefPtr<Gdk::Window> window;
   Glib::RefPtr<Gdk::GC>     gc;
   Glib::RefPtr<Gdk::Pixbuf> final;
   Glib::RefPtr<Gdk::Pixbuf> facia;
   Glib::RefPtr<Gdk::Pixbuf> digits;
   Glib::RefPtr<Gdk::Pixbuf> negdigits;

	void Draw();
	
	virtual void on_realize();
	virtual bool on_expose_event(GdkEventExpose* e);

public:
	BhDisplay();
   BhDisplay(int nd);
	~BhDisplay();
	gint Load(const std::string& facianame, const std::string& digitname);
   gint Load(const std::string& facianame, const std::string& posdigname, const std::string& negdigname);
   int GetXSize();
	void Set(double n);
};

/* @} 
	@} */

}
/* @} */
}

#endif // _BHDISPLAY_H_
