/*
bhnumpad.h
Copyright (C) 2003  Al Kingsley


  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	Part of:
	BhPos, Copyright (C) 2001-2005 Al Kingsley
	BhPos comes with ABSOLUTELY NO WARRANTY. 
*/
#ifndef _BHNUMPAD_H
#define _BHNUMPAD_H

#include <gtkmm/main.h>
#include <gtkmm/table.h>
#include <gtkmm/button.h>
#include <gtkmm/image.h>
#include <gdkmm/color.h>
#include <gdk/gdkkeysyms.h>

namespace bhpos{

/**
 * \ingroup mflib
 * @{	
 */

namespace widget{
/**
 * \defgroup numpad Number Pad
 * @{
 *
 * \ingroup bhwidget
 * @{	
 */
   
typedef int (*NPCALLBACK)(GdkEventKey *);

enum BhNumPadButton{
   BHNUMPAD_0,
   BHNUMPAD_1,
   BHNUMPAD_2,
   BHNUMPAD_3,
   BHNUMPAD_4,
   BHNUMPAD_5,
   BHNUMPAD_6,
   BHNUMPAD_7,
   BHNUMPAD_8,
   BHNUMPAD_9,
   BHNUMPAD_DECIMAL,
   BHNUMPAD_PLUS,
   BHNUMPAD_MINUS,
   BHNUMPAD_EQUAL,
   BHNUMPAD_PGUP,
   BHNUMPAD_UP,
   BHNUMPAD_DOWN,
   BHNUMPAD_PGDOWN,
   BHNUMPAD_RETURN,
   BHNUMPAD_DELETE
};

/*! BhNumPad
 \brief A class to handle a number pad.
*/

class BhNumPad : public Gtk::Table
{
private:
   Gtk::Image   *b0;
   Gtk::Image   *b1;
   Gtk::Image   *b2;
   Gtk::Image   *b3;
   Gtk::Image   *b4;
   Gtk::Image   *b5;
   Gtk::Image   *b6;
   Gtk::Image   *b7;
   Gtk::Image   *b8;
   Gtk::Image   *b9;
   Gtk::Image   *bdecimal;
   Gtk::Image   *bplus;
   Gtk::Image   *bminus;
   Gtk::Image   *bequal;
   Gtk::Image   *bpgup;
   Gtk::Image   *bup;
   Gtk::Image   *bdown;
   Gtk::Image   *bpgdown;
   Gtk::Image   *breturn;
   Gtk::Image   *bdelete;

   Gtk::Button *b_0;
   Gtk::Button *b_1;
   Gtk::Button *b_2;
   Gtk::Button *b_3;
   Gtk::Button *b_4;
   Gtk::Button *b_5;
   Gtk::Button *b_6;
   Gtk::Button *b_7;
   Gtk::Button *b_8;
   Gtk::Button *b_9;
   Gtk::Button *b_decimal;
   Gtk::Button *b_plus;
   Gtk::Button *b_minus;
   Gtk::Button *b_equal;
   Gtk::Button *b_pgup;
   Gtk::Button *b_up;
   Gtk::Button *b_down;
   Gtk::Button *b_pgdown;
   Gtk::Button *b_return;
   Gtk::Button *b_delete;

protected:
   void on_b0_clicked();
   void on_b1_clicked();
   void on_b2_clicked();
   void on_b3_clicked();
   void on_b4_clicked();
   void on_b5_clicked();
   void on_b6_clicked();
   void on_b7_clicked();
   void on_b8_clicked();
   void on_b9_clicked();
   void on_bdecimal_clicked();
   void on_bplus_clicked();
   void on_bminus_clicked();
   void on_bequal_clicked();
   void on_bpgup_clicked();
   void on_bup_clicked();
   void on_bdn_clicked();
   void on_bpgdn_clicked();
   void on_breturn_clicked();
   void on_bdelete_clicked();
   
   bool        bCallback;
   NPCALLBACK  kf_callback;
   sigc::signal<void, BhNumPadButton, int> keypress_signal;

public:
   BhNumPad(Glib::ustring basedir, NPCALLBACK);
   BhNumPad(Glib::ustring basedir);
   ~BhNumPad();
   sigc::signal<void, BhNumPadButton, int> signal_keypress(){ return keypress_signal; }
};
   
/* @} 
	@} */

}
/* @} */
}

#endif
