/*
bhsmartbar.cpp 
Copyright (C) 2004 Al Kingsley

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

   Part of:
   BhPos, Copyright (C) 2001-2005 Al Kingsley
*/
#include "config.h"
#include <gtkmm/box.h>
#include <gtkmm/label.h>
#include "bhsmartbar.h"

namespace bhpos{

namespace widget{

BhSmartBar::BhSmartBar(Gtk::ButtonBoxStyle orientation, BhSmartBarType t, SBCALLBACK cb) : Gtk::HButtonBox(orientation, 10)
{
   type=t;
   /*
   switch(t){
   case BHSMARTBARTYPE_LABEL:
      style=Gtk::TOOLBAR_TEXT;
      break;
   case BHSMARTBARTYPE_IMAGE:
      style=Gtk::TOOLBAR_ICONS;
      break;
   case BHSMARTBARTYPE_LABELIMAGE:
      style=Gtk::TOOLBAR_BOTH;
      break;
   case BHSMARTBARTYPE_LABELIMAGEKEY:
      style=Gtk::TOOLBAR_BOTH;
      break;
   }
   */
   kf_callback=cb;
   bCallback=true;
   //set_orientation(orientation);
   //set_toolbar_style(style);
   //set_tooltips(false);
}

BhSmartBar::BhSmartBar(Gtk::ButtonBoxStyle orientation, BhSmartBarType t) : Gtk::HButtonBox(orientation, 10)
{
   type=t;
   /*
   switch(t){
   case BHSMARTBARTYPE_LABEL:
      style=Gtk::TOOLBAR_TEXT;
      break;
   case BHSMARTBARTYPE_IMAGE:
      style=Gtk::TOOLBAR_ICONS;
      break;
   case BHSMARTBARTYPE_LABELIMAGE:
      style=Gtk::TOOLBAR_BOTH;
      break;
   case BHSMARTBARTYPE_LABELIMAGEKEY:
      style=Gtk::TOOLBAR_BOTH;
      break;
   }
   */
   kf_callback=NULL;
   bCallback=false;
   //set_orientation(orientation);
   //set_toolbar_style(style);
   //set_tooltips(false);
}

BhSmartBar::~BhSmartBar()
{  
}

Gtk::Image *BhSmartBar::AddTextImage(char *imagefile)
{
   Gtk::Image *pm;
   
   pm=manage(new class Gtk::Image(imagefile));
   return pm;
}

bool BhSmartBar::Push(char *label, char *imagefile, unsigned int *k, BhSmartButton kl, int m, char *key="")
{
   Gtk::Image *image;
   Glib::ustring s=label;
   //Gtk::ToolButton *tb;
   if(imagefile!=NULL){
      image=AddTextImage(imagefile);
      if(!image) true;
   }
   
   Gtk::Label *labeller = Gtk::manage(new class Gtk::Label(label));
   Gtk::Label *keyname = Gtk::manage(new class Gtk::Label(key));
   /*
   if(type==BHSMARTBARTYPE_LABEL){
      tb=manage(new class Gtk::ToolButton(s));
   }
   else if(type==BHSMARTBARTYPE_IMAGE){
      tb=manage(new class Gtk::ToolButton(*image));
   }
   else if(type==BHSMARTBARTYPE_LABELIMAGE){ // both
      tb=manage(new class Gtk::ToolButton(*image, s));
   }
   else{ //BHSMARTBARTYPE_LABELIMAGEKEY
   }
   */
   Gtk::VBox *vbox = Gtk::manage(new class Gtk::VBox(false, 3));
   vbox->pack_start(*labeller, Gtk::PACK_SHRINK, 3);
   vbox->pack_start(*image, Gtk::PACK_SHRINK, 3);
   vbox->pack_start(*keyname, Gtk::PACK_SHRINK, 3);
   
   Gtk::Button *button = Gtk::manage(new class Gtk::Button());
   if(!button){
      g_print("no button create\n");
      return true;
   }
   button->add(*vbox);
   /*
   tb=Gtk::manage(new class Gtk::ToolButton(*image, s));
   tb->set_visible_horizontal(true);
   tb->set_visible_vertical(true);
   tb->set_is_important(true);
   image->show();
   tb->show();
   
   tb->signal_clicked().connect(sigc::bind<BhSmartButton>(sigc::mem_fun(*this, &BhSmartBar::on_button_clicked),kl));
   */
   button->signal_clicked().connect(sigc::bind<BhSmartButton>(sigc::mem_fun(*this, &BhSmartBar::on_button_clicked),kl));
   pack_end(*button);
   //append(*tb);

   return false;
}

void BhSmartBar::Insert(int after, char *label, char *imagefile, unsigned int *k, BhSmartButton kl, int m)
{
   Gtk::Image *image;
   Glib::ustring s=label;
   Gtk::ToolButton *tb;
   
   if(imagefile!=NULL){
      image=AddTextImage(imagefile);
      if(!image) return;
   }
   
   if(type==BHSMARTBARTYPE_LABEL){
      tb=manage(new class Gtk::ToolButton(s));
   }
   else if(type==BHSMARTBARTYPE_IMAGE){
      tb=manage(new class Gtk::ToolButton(*image));
   }
   else if(type==BHSMARTBARTYPE_LABELIMAGE){ // both
      tb=manage(new class Gtk::ToolButton(*image, s));
   }
   else{ //BHSMARTBARTYPE_LABELIMAGEKEY
   }

   tb->signal_clicked().connect(sigc::bind<BhSmartButton>(sigc::mem_fun(*this, &BhSmartBar::on_button_clicked),kl));
   pack_end(*tb);
   //append(*tb);
}

void BhSmartBar::Remove(int b)
{
   Gtk::Box_Helpers::BoxList bl=children();
   //Gtk::BoxList::iterator iter_s=bl.begin();
   //Gtk::BoxList::iterator iter_e=bl.end();
   //bl.erase(iter_s, iter_e);

   bl.clear();

   //if(bl.empty()) return;
   //bl.erase(bl.begin(), bl.end());
   /*
   Glib::ListHandle<Gtk::Widget*> z=get_children();
   Glib::ListHandle<Gtk::Widget*>::iterator y=z.begin();
   
   if(z.empty()) return;
   
   if(b==0){
      while(y!=z.end()){ 
         remove(**y);
         y++;
      }
   }*/
   /*
   std::list<Gtk::Widget*> l=get_children();
   std::list<Gtk::Widget*>::iterator i=l.end();
   if(l.empty()) return;
   
   if(b==0){
      while(i!=l.begin()){ 
         remove(**i);
         i--;
      }
   }*/
   /*
   GtkContainer *container=gobj(); 
   GList *iter;
   //GtkRequisition old_req, new_req;
   //gtk_widget_size_request(container, &old_req);
 
   iter = gtk_container_get_children(GTK_CONTAINER(container));
   
   while(iter){
      GtkWidget *w = GTK_WIDGET(iter->data);
      gtk_container_remove(contatiner, w);
      //gtk_widget_hide(w);
      iter = g_list_next(iter);
   }
 
   //gtk_widget_size_request(container, &new_req);
   */
}

void BhSmartBar::on_button_clicked(BhSmartButton b)
{
   GdkEventKey keyev;
   
   memset(&keyev, 0, sizeof(keyev));
   
   switch(b){
   case BHSB_EXIT:
   case BHSB_LOGOUT:
   case BHSB_CANCEL:
   case BHSB_CLEAR:
      keyev.keyval=GDK_Escape;
      break;
   
   case BHSB_QUANTITY:
      keyev.keyval=GDK_equal;
      break;
   
   case BHSB_REQUEST:
      keyev.keyval=GDK_F13;
      break;
   
   case BHSB_SALEPRICE:
      keyev.keyval=GDK_F2;
      break;
   
   case BHSB_TRANSCYCLE:
      keyev.keyval=GDK_F4;
      break;
   
   case BHSB_TOTAL:
      keyev.keyval=GDK_Return;
      break;
   
   case BHSB_CASH:
   case BHSB_CASHITEM:
      keyev.keyval=GDK_F5;
      break;
   
   case BHSB_CHEQUE:
      keyev.keyval=GDK_F6;
      break;
   
   case BHSB_CREDIT:
      keyev.keyval=GDK_F7;
      break;
   
   case BHSB_CHARGE:
      keyev.keyval=GDK_F8;
      break;
   
   case BHSB_ALLAMOUNT:
      keyev.keyval=GDK_Return;
      break;
   
   case BHSB_COMMIT:
      keyev.keyval=GDK_Return;
      break;
   
   case BHSB_RETURN:
      keyev.keyval=GDK_F10;
      break;
   
   case BHSB_PLULOOKUP:
      keyev.keyval=GDK_F11;
      break;
   
   case BHSB_REMOVE:
      keyev.keyval=GDK_F12;
      break;
   
   case BHSB_PAYIN:
      keyev.keyval=GDK_F3;
      keyev.state=GDK_SHIFT_MASK;
      break;
   
   case BHSB_PAYOUT:
      keyev.keyval=GDK_F3;
      break;
   
   case BHSB_DISCOUNT:
      keyev.keyval=GDK_F5;
      keyev.state=GDK_SHIFT_MASK;
      break;
   
   case BHSB_RENTAL:
   case BHSB_DELIVERY:
   case BHSB_EPHEMERAL:
   case BHSB_LAYBY:
   case BHSB_NOSALE:
      break;
   
   case BHSB_NEWCUST:
      keyev.keyval=GDK_N;
      keyev.state=GDK_SHIFT_MASK;
      break;
   
   case BHSB_FINDCUST:
      keyev.keyval=GDK_C;
      keyev.state=GDK_CONTROL_MASK;
      break;
   
   case BHSB_INCREMENT:
      keyev.keyval=GDK_plus;
      break;
  
   case BHSB_DECREMENT:
      keyev.keyval=GDK_minus;
      break;
   
   case BHSB_QTYSET:
      keyev.keyval=GDK_equal;
      break;
   
   case BHSB_DELETE:
      keyev.keyval=GDK_Delete;
      break;
   
   case BHSB_RETURNTRANS:
      keyev.keyval=GDK_F10;
      keyev.state=GDK_SHIFT_MASK;
      break;
   
   case BHSB_RETURNITEM:
      keyev.keyval=GDK_F10;
      break;
   }
   
   if(!bCallback){
      keypress_signal.emit(b, &keyev);
   }
   else{
      kf_callback(&keyev);
   }
   
   /*
   m=button->GetKey(key, &m);
   if(m==-1 || m==0) return;
   
   p=key;
   while(m){
      keyev.keyval=*p;
      keyev.state=m;
      kf_callback(&keyev);
   }*/
}

}

}
